//> ===>
//> Title: Back Stab
//> Author: Truce
//> ===>

package backStab {
	function ProjectileData::Damage(%t,%obj,%col,%a,%pos,%b) {
		%objS=%obj.sourceObject;
		%bs=%obj.getDatablock().backStab/2;
		%objC=%objS.getClassName();
		%colC=%col.getClassName();
		if(%bs>0&&%bs<360&&(%objC$="Player"||%objC$="AIPlayer")&&(%colC$="Player"||%colC$="AIPlayer")) {
			%objR=%objS.getRotation();
			%colR=%col.getRotation();
			%max=%colR+%bs;
			if(%max>360)
				%max-=360;
			%min=%colR-%bs;
			if(%min<0)
				%min+=360;
			if(%min>%max)
				%state=(%objR>=%min||%objR<=%max);
			else
				%state=(%objR>=%min&&%objR<=%max);
			if(%state) {
				%db=%col.getDatablock();
				%db.damage(%col,%obj,%pos,%db.maxDamage,%t.directDamageType);
				return;
			}
		}
		Parent::Damage(%t,%obj,%col,%a,%pos,%b);
	}
};
activatePackage(backStab);
function Player::getRotation(%obj) {
	%pi=3.1415926535897932384626433;
	%fv=%obj.getForwardVector();
	%x=mASin(getWord(%fv,0))*180/%pi;
	return 180-mFloatLength(%x/mAbs(%x),0)*(180-(mACos(getWord(%fv,1))*180/%pi));
}
function AIPlayer::getRotation(%obj) {
	%pi=3.1415926535897932384626433;
	%fv=%obj.getForwardVector();
	%x=mASin(getWord(%fv,0))*180/%pi;
	return 180-mFloatLength(%x/mAbs(%x),0)*(180-(mACos(getWord(%fv,1))*180/%pi));
}